%define py_site_pkgs %(python -c "from distutils.sysconfig import get_python_lib as f;print f()")
%define __os_install_post %{nil}
%define _localdir %{_usr}/local
%define _sharedir %{_usr}/share
%define _jbossdir %{_sharedir}/jboss-as
%define __getent /usr/bin/getent
%define __groupadd /usr/sbin/groupadd
%define __useradd /usr/sbin/useradd
%define __usermod /usr/sbin/usermod
%define _engineeardir %{_datadir}/%{name}/engine.ear

Name: ovirt-engine
Version: 3.0.0_0001
Release: 1.6%{?dist}
Source: %{name}-%{version}.tar.gz
License: ASL 2.0
Summary: Management server for Open Virtualization
Group: Virtualization/Management
URL: http://www.ovirt.org

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}
BuildArch: x86_64
BuildRequires: unzip
BuildRequires: openssl-devel
BuildRequires: gcc-c++
Requires: java-1.6.0-openjdk
Requires: policycoreutils-python
Requires: cracklib-python
Requires: ntp
Requires: bind-utils
Requires: postgresql-server >= 8.4.7
Requires: postgresql-contrib >= 8.4.7
Requires: postgresql-jdbc
Requires: %{name}-setup
Requires: %{name}-jboss-deps
Requires: %{name}-backend
Requires: %{name}-restapi
Requires: %{name}-genericapi
Requires: %{name}-userportal
Requires: %{name}-config
Requires: %{name}-notification-service
Requires: %{name}-iso-uploader
Requires: %{name}-log-collector
Requires: %{name}-dbscripts
Requires: %{name}-webadmin-portal
Requires: vdsm-bootstrap
Requires: openssl

%description
Open Virtualization Manager is a feature-rich
server virtualization management system that provides advanced capabilities
for managing the Open virtualization infrastructure for Servers and Desktops.

%package jboss-deps
Summary: Jboss dependencies of Open Virtualization Manager
Group: Virtualization/Management
Requires: ovirt-engine-jbossas
Requires: %{name} = %{version}-%{release}
Requires: hsqldb >= 1:1.8.0.10-9
Requires: jakarta-commons-discovery >= 1:0.4-7

%description jboss-deps
The JBOSS dependencies of Open Virtualization Manager

%package backend
Summary: Engine core of Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description backend
The backend engine of Open Virtualization Manager

%package restapi
Summary: Open API for Red Hat Enterprise Virtualization Manager
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description restapi
The Open API for Red Hat Enterprise Virtualization Manager

%package genericapi
Summary: Generic API for Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description genericapi
The generic API for Open Virtualization Manager

%package iso-uploader
Summary: ISO Uploader tool for Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name}
Requires: python-lxml

%description iso-uploader
ISO Uploader tool for Open Virtualization Manager

%package log-collector
Summary: Log Collector tool for Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name}
Requires: sos
Requires: python-lxml

%description log-collector
Log Collector tool for Open Virtualization Manager

%package setup
Summary: Setup and upgrade scripts for Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name}
Requires: lsof
Requires: nfs-utils

%description setup
Setup and upgrade scripts for Open Virtualization Manager

%package dbscripts
Summary: Database scripts for Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name}

%description dbscripts
Database scripts for Open Virtualization Manager

%package userportal
Summary: User Portal of Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}

%description userportal
The user portal interface to Open Virtualization Manager

%package webadmin-portal
Summary: Web Admin Portal of Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name}

%description webadmin-portal
The web administration interface to Open Virtualization Manager

%package tools-common
Summary: Common libraries for  Open Virtualization Manager Tools
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}
Requires: jakarta-commons-collections
Requires: jakarta-commons-logging
Requires: jakarta-commons-lang
Requires: jakarta-commons-codec
Requires: log4j
Requires: jakarta-commons-configuration
Requires: jakarta-commons-jxpath

%description tools-common
The common libraries used by Open Virtualization Manager Tools

%package notification-service
Summary: Notification service for Open Virtualization Manager Tools
Group: Virtualization/Management
Requires: %{name} = %{version}-%{release}
Requires: %{name}-tools-common = %{version}-%{release}
Requires: classpathx-mail

%description notification-service
The notification service used by Open Virtualization Manager

%package config
Summary: Configuration tool for  Open Virtualization Manager
Group: Virtualization/Management
Requires: %{name}-tools-common = %{version}-%{release}

%description config
The configuration tool for Open Virtualization Manager

%prep
%setup -c -q

%build

%install
rm -rf %{buildroot}/*
make PREFIX=%{buildroot}/ install


%preun
#raw
if [ "$1" -eq 0 ]
then
    curdate=`date +"%Y_%m_%d_%H_%M_%%S"`
    if [[ -d %{_sysconfdir}/pki/%{name} ]]; then
        mkdir -p %{_sysconfdir}/pki/%{name}-backups/%{name}-${curdate}
        #backup whole 'rhevm' dir into the backup dir with current date
        cp -pR %{_sysconfdir}/pki/%{name}/ %{_sysconfdir}/pki/%{name}-backups/%{name}-${curdate}/
    fi
fi

%postun
if [ "$1" -eq 0 ]
then
    if [[ -d %{_sysconfdir}/pki/%{name} ]]; then
	    rm -rf %{_sysconfdir}/pki/%{name}
	fi
fi
#end raw

%post
#ln -s %{_datadir}/vdsm-bootstrap %{_engineeardir}/components.war/vds &> /dev/null || /bin/true
# TODO: remove copy of vds dir after Jboss7.x will support symbolic links
if [[ -L %{_engineeardir}/components.war/vds ]]; then
    unlink %{_engineeardir}/components.war/vds &> /dev/null || /bin/true
fi

mkdir -p %{_engineeardir}/components.war/vds &> /dev/null || /bin/true
cp -rpf %{_datadir}/vdsm-bootstrap/* %{_engineeardir}/components.war/vds/ &> /dev/null || /bin/true

%pre
%{__getent} group kvm > /dev/null || %{__groupadd} -g 36 -r kvm
%{__getent} passwd vdsm > /dev/null || %{__useradd} -u 36 -g kvm -o -r vdsm -c "Ovirt node manager" -d / -s /sbin/nologin

%{__getent} group ovirt > /dev/null || %{__groupadd} -g 108 ovirt
%{__getent} passwd ovirt > /dev/null || %{__useradd} -u 108 -g ovirt -o -r ovirt -c "Ovirt Manager" -d /var/lib/ovirt -s /sbin/nologin
%{__getent} passwd jboss-as > /dev/null && %{__usermod} -a -G jboss-as ovirt > /dev/null

%pre notification-service
%{__getent} group ovirt > /dev/null || %{__groupadd} -g 108 ovirt
%{__getent} passwd ovirt > /dev/null || %{__useradd} -u 108 -g ovirt -o -r ovirt -c "Ovirt Manager" -d /var/lib/ovirt -s /sbin/nologin
%{__getent} passwd jboss-as > /dev/null && %{__usermod} -a -G jboss-as ovirt > /dev/null

%post notification-service
%{__chown} ovirt:ovirt /etc/ovirt-engine/notifier/notifier.conf > /dev/null || /bin/true

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %{_datadir}/%{name}
%doc %{_datadir}/%{name}/LICENSE
%dir %{_datadir}/%{name}/resources
%dir %{_datadir}/%{name}/ovirt-isos
%dir %{_datadir}/%{name}/db-backups
%dir %{_datadir}/%{name}/scripts
%dir %{_localstatedir}/run/%{name}
%dir %attr (755,jboss-as,jboss-as) %{_var}/log/%{name}
%dir %attr (755,jboss-as,jboss-as) %{_var}/lock/%{name}
%dir %{_datadir}/%{name}/sysprep
%attr (755,root,root) %{_datadir}/%{name}/kerberos
%{_datadir}/%{name}/conf
%{_datadir}/%{name}/3rd-party-lib
%attr (755,root,root) %{_datadir}/%{name}/scripts/vds_installer.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/ovirtlogrot.sh
%attr (755,root,root) %{_sysconfdir}/cron.daily/ovirt-cron
%attr (644,root,root) %{_sysconfdir}/tmpfiles.d/ovirt-engine.conf
%attr (755,jboss-as,jboss-as) %{_datadir}/%{name}/resources/jboss
%dir %{_sysconfdir}/%{name}
%attr (755,jboss-as,jboss-as) %{_sysconfdir}/pki/%{name}
%attr (640,jboss-as,jboss-as) %config(noreplace) %{_sysconfdir}/%{name}/engine.conf

%config(noreplace) %{_sysconfdir}/pki/%{name}/database.txt
%config(noreplace) %{_sysconfdir}/pki/%{name}/serial.txt
%config(noreplace) %{_sysconfdir}/pki/%{name}/cacert.template
%config(noreplace) %{_sysconfdir}/pki/%{name}/cert.template
%config(noreplace) %{_sysconfdir}/%{name}/web-conf.js
%config(noreplace) %{_datadir}/%{name}/sysprep/sysprep.2k3
%config(noreplace) %{_datadir}/%{name}/sysprep/sysprep.2k8
%config(noreplace) %{_datadir}/%{name}/sysprep/sysprep.2k8x86
%config(noreplace) %{_datadir}/%{name}/sysprep/sysprep.w7
%config(noreplace) %{_datadir}/%{name}/sysprep/sysprep.w7x64
%config(noreplace) %{_datadir}/%{name}/sysprep/sysprep.xp
%{_jbossdir}/modules/org/postgresql/main/postgresql-jdbc.jar
%attr (755,root,root) %{_sysconfdir}/pki/%{name}/pubkey2ssh

%files backend
%dir %{_engineeardir}
%{_engineeardir}/META-INF
%{_engineeardir}/lib
%{_engineeardir}/engine-bll.jar
%{_engineeardir}/engine-scheduler.jar
%{_engineeardir}/engine-vdsbroker.jar
%{_engineeardir}/ovirtengineweb.war
%{_engineeardir}/ovirtengine.war
%{_engineeardir}/components.war
%dir %{_engineeardir}/webadmin.war

%files setup
%attr (755,root,root) %{_datadir}/%{name}/scripts/basedefs.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/engine_validators.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/common_utils.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/output_messages.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/nfsutils.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/engine-setup.py*
%attr (755,root,root) %{_datadir}/%{name}/scripts/engine-cleanup.py*
%attr (750,root,root) %{_bindir}/engine-setup
%attr (750,root,root) %{_bindir}/engine-cleanup

%files dbscripts
%attr (755,root,root) %{_datadir}/%{name}/dbscripts

%files jboss-deps
%defattr(-,root,root,-)

%files restapi
%dir %{_engineeardir}
%{_engineeardir}/restapi.war

%files genericapi
%dir %{_engineeardir}
%{_engineeardir}/engine-genericapi.jar

%files userportal
%dir %{_engineeardir}
%config(noreplace) %{_engineeardir}/userportal.war/org.ovirt.engine.ui.userportal.UserPortal/consoles/spice/usbfilter.txt
%{_engineeardir}/userportal.war

%files webadmin-portal
%dir %{_engineeardir}
%{_engineeardir}/webadmin.war

%files iso-uploader
%{_datadir}/%{name}/iso-uploader
%{_bindir}/engine-iso-uploader
%config(noreplace) %{_sysconfdir}/%{name}/isouploader.conf
%doc  %{_mandir}/man8/engine-iso-uploader.8.gz

%files log-collector
%attr (755,root,root) %{_datadir}/%{name}/log-collector
%attr (755,root,root) %{py_site_pkgs}/sos/plugins/engine.py*
%attr (755,root,root) %{py_site_pkgs}/sos/plugins/jboss.py*
%attr (755,root,root) %{py_site_pkgs}/sos/plugins/postgresql.py*
%{_bindir}/engine-log-collector
%config(noreplace) %{_sysconfdir}/%{name}/logcollector.conf
%doc  %{_mandir}/man8/engine-log-collector.8.gz

%files tools-common
%{_datadir}/java/engine-tools-common-3.0.0-0001.jar
%{_datadir}/java/engine-tools-common.jar

%files config
%{_datadir}/%{name}/engine-config
%{_sysconfdir}/%{name}/engine-config
%{_bindir}/engine-config
%{_datadir}/%{name}/engine-manage-domains
%{_sysconfdir}/%{name}/engine-manage-domains
%{_bindir}/engine-manage-domains

%files notification-service
%defattr(-,ovirt,ovirt,-)
%dir %attr (755,ovirt,ovirt) %{_var}/log/%{name}/notifier
%dir %attr (755,ovirt,ovirt) %{_localstatedir}/run/%{name}/notifier
%{_datadir}/%{name}/notifier
%{_sysconfdir}/%{name}/notifier
%attr (755,root,root) %{_sysconfdir}/init.d/engine-notifierd
%config(noreplace) %{_sysconfdir}/%{name}/notifier/notifier.conf

%changelog
* Wed Jan 04 2012 Ronen Angluste <ranglust@redhat.com> - 3.0.0-1
- Adjust code for Jboss AS 7.1
* Sun Dec 11 2011 Ronen Angluster <ranglust@redhat.com> - 3.0.0-1
- Moved all hard coded paths to macros
* Wed Oct 26 2011 Ronen Angluster <ranglust@redhat.com> - 3.0.0-1
- Initial build
- Cloned from RHEVM spec file
